/***********************************************************************/
/*                                                                     */
/*  FILE        :MP3_Player.c                                          */
/*  DATE        :Fri, Jul 14, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :SH7144F                                               */
/*                                                                     */
/*  Copyright (C) 2004  Yuji Nakamura      All rights reserved         */
/*                                                                     */
/***********************************************************************/
                  
#include "iodefine.h" 
#include <machine.h>

//#include "typedefine.h"
#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios                  
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif
#ifdef __cplusplus
extern "C" {
void abort(void);
#endif
void main(void);
#ifdef __cplusplus
}
#endif


////////////////////////////
// Oϐ
char	Data[1024*5];
volatile int	DCount = 0;
volatile char	*pDRead = &Data[0];
volatile char	*pDWrite = &Data[0];

////////////////////////////
// MP3 I/O Ports
#define	MP3_DREQ	( PB.DR.BIT.B5 )		// DREQ
#define	MP3_XDCS	( PA.DR.BIT.B8 )		// xDCS
#define	MP3_XCS		( PB.DR.BIT.B4 )		// xCS
#define	MP3_DFULL	( PE.DRL.BIT.B15 )		// DATA FULL
#define	MP3_TX		( SCI2.TDR )			// REG ( Write )
#define	MP3_RX		( SCI2.RDR )			// REG ( Read )

////////////////////////////
// MP3 I/O Ports
#define	DS_CMT	(CMT0.CMCSR.BIT.CMIE=0)		// CMT荞 Disable
#define	EN_CMT	(CMT0.CMCSR.BIT.CMIE=1)		// CMT荞 Enable

////////////////////////////
// C[`
void main(void)
{
	int i, x,c;
	char m[256];

	init_SCI();					// e탌WX^
	init_CMT();					// ^C}[
	init_VLSI();				// VS1011 

	MP3_XDCS = 0;				// xDCS Negate
	MP3_XCS = 1;				// xCS Assert

	while( 1 ) {

		///////////////////
		//  IIC 
		IIC.SCRX.BIT.IICE = 1;
		IIC.ICCR.BIT.ICE  = 0;
		IIC._SAR.BYTE = 0xA6;			// Slave Addr = 0xA6, FS=0 
		IIC.SARX.BYTE = 1;				// FSX=1 (  )
		IIC.ICCR.BIT.ICE = 1;
		IIC.ICSR.BIT.ACKB = 0;			// ACK = 0
		IIC.SCRX.BIT.IICX0 = 0;
		IIC.SCRX.BIT.HNDS = 1;			// HNDS@\gp
		IIC.ICMR.BIT.CKS = 3;			// 391KHz@25MHz
		IIC.ICCR.BIT._MST = IIC.ICCR.BIT.TRS = 0;		// SlaveM[h


		IIC.ICCR.BIT.IRIC = 0;

		if ( IIC.SCRX.BIT.ICDRF0 ) {
			x = IIC.ICDR;					// ǂݎcRead
			IIC.ICCR.BIT.IRIC = 0;
		}


		// M

		while ( DCount >= sizeof(Data) - 2048 );	// 2048oCgȏ̋󂫂܂ő҂

		MP3_DFULL = 0;						// ProDigioƂ̃nhVFCN

		while( IIC.ICCR.BIT.IRIC == 0 );
		IIC.ICCR.BIT.IRIC = 0;
		x = IIC.ICDR;						// 1ڂ̓_~[

		while( IIC.ICCR.BIT.IRIC == 0 );
		IIC.ICCR.BIT.IRIC = 0;
		c = IIC.ICDR * 0x100;				// oCg(H)

		while( IIC.ICCR.BIT.IRIC == 0 );
		IIC.ICCR.BIT.IRIC = 0;
		c = c + IIC.ICDR;					// oCg(L)

		if ( c == 0 ) {						// R}h[h

			while( IIC.ICCR.BIT.IRIC == 0 );
			IIC.ICCR.BIT.IRIC = 0;
			m[0] = IIC.ICDR;

			while( IIC.ICCR.BIT.IRIC == 0 );
			IIC.ICCR.BIT.IRIC = 0;
			IIC.ICSR.BIT.ACKB = 1;

			m[1] = IIC.ICDR;

			while( IIC.ICCR.BIT.IRIC == 0 );
			IIC.ICCR.BIT.IRIC = 0;

			if ( m[0] == 1 ) {				// STOPR}h

				DS_CMT;							// CMT荞 Disable

				init_VLSI();					// VS1011

				MP3_XDCS = 0;					// BSYNC Assert
				MP3_XCS = 1;					// xCS Negate

				DCount = 0;
				pDWrite = pDRead = &Data[0];	// obt@E|C^SĖ߂

				EN_CMT;							// CMT荞 Enable
			}

			continue;
		}


		for ( i=0; i<c-1; i++ ) {
			while( IIC.ICCR.BIT.IRIC == 0 );
			IIC.ICCR.BIT.IRIC = 0;
			*pDWrite++ = IIC.ICDR;
			DS_CMT;							// CMT荞 Disable
			DCount++;
			EN_CMT;							// CMT荞 Enable
			if ( pDWrite >= &Data[sizeof(Data)] )
				pDWrite = &Data[0];
		}
		while( IIC.ICCR.BIT.IRIC == 0 );
		IIC.ICCR.BIT.IRIC = 0;
		IIC.ICSR.BIT.ACKB = 1;

		*pDWrite++ = IIC.ICDR;
		DS_CMT;								// CMT荞 Disable
		DCount++;
		EN_CMT;								// CMT荞 Enable
		if ( pDWrite >= &Data[sizeof(Data)] )
			pDWrite = &Data[0];

		while( IIC.ICCR.BIT.IRIC == 0 );
		IIC.ICCR.BIT.IRIC = 0;

		if ( DCount >= 4*1024 )
			MP3_DFULL = 1;			// WSC~߂
		else
			MP3_DFULL = 0;

	}
}


////////////////////////////
// e탌WX^̏ݒ
init_SCI(void) {

	int	x;

	MST.CR1.BIT._SCI0=0;	// SCI_0L
	MST.CR1.BIT._SCI1=0;	// SCI_1L
	MST.CR1.BIT._SCI2=0;	// SCI_2L
	MST.CR1.BIT._IIC=0;		// IICL

	SCI0.SCR.BYTE=0;
	SCI0.SCR.BIT.CKE=0;		// CKE1=CKE0=0
	SCI0.SMR.BYTE=0;
	SCI0.BRR=38;			// @24MHz -> 19200bps

	SCI1.SCR.BYTE=0;
	SCI1.SCR.BIT.CKE=0;		// CKE1=CKE0=0
	SCI1.SMR.BYTE=0;
	SCI1.BRR=38;			// @24MHz -> 19200bps

	SCI2.SCR.BYTE=0;
//	SCI2.SCR.BIT.CKE=0;		// CKE1=CKE0=0
	SCI2.SMR.BYTE=0;
	SCI2.SMR.BIT.CA=1;		// NbN
	SCI2.SMR.BIT.CKS=0;
	SCI2.BRR=5;			// 250000bps
	SCI2.SDCR.BIT.DIR=1;	// MSB First

	PFC.PAIORL.WORD = 0x8300; //PA8/9/15(o)

	PFC.PACRL2.BIT.PA4MD=1;  //PA4 -> TXD1(o)
	PFC.PACRL2.BIT.PA3MD=1;  //PA3 -> RXD1()

	PFC.PECRL1.BIT.PE10MD=2; //PE10 -> TXD2(o)
	PFC.PECRL2.BIT.PE7MD=2;  //PE7  -> RXD2()
	PFC.PECRL1.BIT.PE8MD=2;  //PE8  -> SCLK2(o)
	PFC.PEIORL.BIT.B8=1;  	 //PE8  -> o
	MP3_DFULL = 1;
	PFC.PEIORL.BIT.B15=1; 	 // óinhVFCNpj

	MP3_XCS = 1;			// xCS Negate
	PFC.PBIOR.BIT.B4 = 1;	// PB4 o(xCS)
//	PFC.PBIOR.BIT.B5 = 1;	// PB5 o(CLK)

	PFC.PBCR1.BIT.PB3MD=1;  //PB3 -> IIC(SDA)
	PFC.PBCR2.BIT.PB3MD=0;  //PB3 -> IIC
	PFC.PBCR1.BIT.PB2MD=1;  //PB2 -> IIC(SCL)
	PFC.PBCR2.BIT.PB2MD=0;  //PB2 -> IIC

	SCI1.SCR.BIT.TE=1,SCI1.SCR.BIT.RE=1;	// M
//	SCI2.SCR.BIT.TE=1;SCI2.SCR.BIT.RE=1;	// M

//	x=SCI2.RDR;
//	SCI2.SSR.BIT.RDRF=0;
	SCI2.SCR.BYTE = 0x30;	// M
}

///////////////////////////////////////
// Compare Mutch Timer 
///////////////////////////////////////
init_CMT(){
	MST.CR2.BIT._CMT=0;			// Compare Mutch Timer L
	//CMT0.CMCSR.WORD=0x0041;	// 	荞݋@32@750kHz
	CMT0.CMCSR.BIT.CMIE=1;
	CMT0.CMCSR.BIT.CMF=0;
	CMT0.CMCSR.BIT.CKS=01;

	CMT0.CMCOR=6;			// 3KHz
	CMT0.CMCNT=0;			// l
	INTC.IPRG.BIT._CMT0=15;	// 荞ݗDx15
	set_imask(0);  
	CMT.CMSTR.BIT.STR0=1;	// count start
}

///////////////////////////////////////
// MP3 Decorder ( V1011e ) Accesss
///////////////////////////////////////
// PoCg]
int MP3Putc(char c) {

	int	x;

	while ( SCI2.SSR.BIT.TDRE == 0 );	// M\H

	MP3_TX = c;							// Mf[^
	SCI2.SSR.BIT.TDRE = 0;				// SEND

	while ( SCI2.SSR.BIT.RDRF == 0 );	// MH
	x = MP3_RX & 0xff;					// Mf[^
	SCI2.SSR.BIT.RDRF = 0;				// RECEIVE

	return x;
}

///////////////////////////////////////
// PoCgWX^
void MP3RegWrite( int adrs, int data ) {

	int i, dmy;

	MP3_XCS = 0;						// xCS Active
	MP3Putc( 0x02 );
	MP3Putc( adrs );
	MP3Putc( data / 256 );
	MP3Putc( data % 256 );
	MP3_XCS = 1;						// xCS Negate

}

///////////////////////////////////////
// PoCgWX^ǂݍ
int MP3RegRead( int adrs ) {

	int x;

	MP3_XCS = 0;						// xCS Active
	MP3Putc( 0x03 );
	MP3Putc( adrs );
	x = MP3Putc( 0 ) << 8;				// CLKõ_~[Cg
	x = x | MP3Putc( 0 );				// CLKõ_~[Cg
	MP3_XCS = 1;						// xCS Negate

	return x;
}

#pragma interrupt MP3Trans

///////////////////////////////////////
// MP3f[^]
void MP3Trans() {			/// CMT ɂIɊ荞݂ŌĂяo

	int c, i, dt, data;

	CMT0.CMCSR.BIT.CMF=0;	// Clear Compare Mutch Flag

	if ( DCount > 32 ) {	// FIFO32bytê

		if ( MP3_DREQ == 1 ) {

			for ( c=0; c<32; c++ ) {

				if ( MP3_DREQ == 0 )
					break;

				data = *pDRead++;
				DCount--;
				if ( pDRead >= &Data[sizeof(Data)] )
					pDRead = &Data[0];
				MP3Putc( data );
			}
		}
	}
}

///////////////////////////////////////
// MP3fR[_
init_VLSI()
{
	int	i, x;

	MP3_XDCS = 1;						// BSYNC(xDCS)="H"
	MP3_XCS = 0;						// xCS Negate

	while( MP3_DREQ == 0 );				// DREQ Check


	MP3RegWrite( 0, 0x0004 );			// Software Reset

	for ( i=0; i<1000; i++ )
		x = PB.DR.WORD;					// 2usȏwait

	MP3RegWrite( 0, 0x0000 );			// Software Reset 

	while( MP3_DREQ == 0 );				// DREQ Check

	MP3RegWrite( 0, 0x0880 );			// SM_SDINEW,SM_SDISHARE,LOUDNESS
	MP3RegWrite( 0x03, 0x8000 + (int)((14318180)/2000) );		// 14.318MHz
	MP3RegWrite( 0x0B, 0x1818 );		// Volime EƂ0x10

}


#ifdef __cplusplus
void abort(void)
{
	
}
#endif
